﻿/*

Copyright (c) <2012>, Intel Corporation All Rights Reserved.
 
The source code, information and material ("Material") contained herein is owned by Intel Corporation or its suppliers or licensors, 
and title to such Material remains with Intel Corporation or its suppliers or licensors. The Material contains proprietary information 
of Intel or its suppliers and licensors. The Material is protected by worldwide copyright laws and treaty provisions. No part of the Material 
may be used, copied, reproduced, modified, published, uploaded, posted, transmitted, distributed or disclosed in any way without Intel's 
prior express written permission. No license under any patent, copyright or other intellectual property rights in the Material is granted 
to or conferred upon you, either expressly, by implication, inducement, estoppel or otherwise. Any license under such intellectual 
property rights must be express and approved by Intel in writing.
 
Unless otherwise agreed by Intel in writing, you may not remove or alter this notice or any other notice embedded in Materials by Intel 
or Intel’s suppliers or licensors in any way.

*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace PhotoApp.Utility
{
    class WebCamHelper
    {
        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long Init(int rAngle);

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long StartPreview(IntPtr windowHandle, Int32 x, Int32 y, Int32 width, Int32 height, Boolean bFullScreen);

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long SetPreviewWindow(IntPtr windowHandle, int x, int y, int width, int height);

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long CaptureImage([MarshalAs(UnmanagedType.LPWStr)] string filename);

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long UnInit();

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long RestartPreview();

        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long StopPreview();

        /*
	    ROTATE_NONE						= 0,
	    ROTATE_90_DEGREES_CLOCKWISE		= 1,
	    ROTATE_180_DEGREES_CLOCKWISE	= 2,
	    ROTATE_270_DEGREES_CLOCKWISE	= 3,
	    ROTATE_FLIP_VERTICAL			= 4,
	    ROTATE_FLIP_HORIZONTAL			= 5,
        */
        [DllImport("PhotoAppWebCamDll.dll", SetLastError = true)]
        public static extern long RotateVideo(int rAngle);
    }
}
